//ImgViewer.cpp

#include <stdio.h>
#include <GL/glut.h>

#include "SDL.h"

FILE * image;

int InitOpenGL()
{
	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

	//float ratio = (float) WIDTH / (float) HEIGHT;
	glShadeModel( GL_SMOOTH );

	glCullFace( GL_BACK );
	glFrontFace( GL_CCW );
	glEnable( GL_CULL_FACE );

	glClearColor( 0, 0, 0, 0 );

	glViewport( 25, 25, 255, 255 );

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();

	gluOrtho2D( 0, 255, 0, 255 );

	return 1;
}

int InitSDL()
{
	SDL_Init( SDL_INIT_VIDEO );

	SDL_Surface * screen = SDL_SetVideoMode( 305, 305, 8, SDL_HWSURFACE | SDL_OPENGL 
												| SDL_ANYFORMAT /*| SDL_FULLSCREEN*/ );

	SDL_WM_SetCaption("Karg's .img Viewer", "");

	InitOpenGL();

	return 1;
}

int ShowImage()
{
	float color;
	int i = 0, j = 0;
	glBegin( GL_POINTS );
	for ( i = 255; i > -1; --i )
	{
		for ( j = 0; j < 256; ++j )
		{
			color = (float)(fgetc( image )) / 256.0f;
			glColor3f( color, color, color );
			glVertex2d( j, i );
		}
	}
	glEnd();

	SDL_GL_SwapBuffers();
	return 1;
}

int HandleKeyPress( SDL_Event * event )
{
	switch( event->key.keysym.sym)
	{
	case SDLK_ESCAPE:		  //quit
		return 0;
		break;
	default:				  //keep it running!
		return 1;
		break;
	}
}

int HandleEvents()
{
	static SDL_Event event;
	int status = 1;  //Should I keep going?

	while( SDL_PollEvent( &event ) )
	{
		switch( event.type )
		{
			case SDL_QUIT:
				status = 0;
				break;
			case SDL_KEYDOWN:  //Key press
				status = HandleKeyPress( &event );
				break;
		}
	}
	return status;
}


int main(int argc, char * argv[])
{
	if( argc != 2 ) 
	{
		printf( "usage %s filename\n", argv[0] );
		return 0;
	}


	if( (image = fopen( argv[1], "rb" )) == NULL )
	{
		printf( "error opening %s\n", argv[1] );
		return 0;
	}

	InitSDL();

	ShowImage();

	while( HandleEvents() );

	if( image != NULL )
		fclose( image );
	return 1;
}